'==============================================================================
'
'  ANIMATE.BAS example for PowerBASIC for Windows
'  Copyright (c) 2002-2008 PowerBASIC, Inc.
'  All Rights Reserved.
'
'  Demo of how to play an AVI clip using the animation common control.
'
'==============================================================================

#COMPILER PBWIN 9
#COMPILE EXE
#DIM ALL

#RESOURCE "ANIMATE.PBR"


'------------------------------------------------------------------------------
' Initial Declares - eliminate unnecessary functions in COMMCTRL.INC
'------------------------------------------------------------------------------
' %NOANIMATE       = 1  ' Animate control
%NOBUTTON          = 1  ' Button
%NOCOMBO           = 1  ' Combo box
%NOCOMBOEX         = 1  ' ComboBoxEx
%NODATETIMEPICK    = 1  ' Date/time picker
%NODRAGLIST        = 1  ' Drag list control
%NOEDIT            = 1  ' Edit control
%NOFLATSBAPIS      = 1  ' Flat scroll bar
%NOHEADER          = 1  ' Header control
%NOHOTKEY          = 1  ' HotKey control
%NOIMAGELIST       = 1  ' Image APIs
%NOIPADDRESS       = 1  ' IP Address edit control
%NOLIST            = 1  ' List box control
%NOLISTVIEW        = 1  ' ListView control
%NOMENUHELP        = 1  ' Menu help
%NOMONTHCAL        = 1  ' MonthCal
%NOMUI             = 1  ' MUI
%NONATIVEFONTCTL   = 1  ' Native Font control
%NOPAGESCROLLER    = 1  ' Pager
%NOPROGRESS        = 1  ' Progress control
%NOREBAR           = 1  ' Rebar control
%NOSTATUSBAR       = 1  ' Status bar
%NOTABCONTROL      = 1  ' Tab control
%NOTOOLBAR         = 1  ' Tool bar
%NOTOOLTIPS        = 1  ' Tool tips
%NOTRACKBAR        = 1  ' Track bar
%NOTRACKMOUSEEVENT = 1  ' Track Mouse Event
%NOTREEVIEW        = 1  ' TreeView
%NOUPDOWN          = 1  ' Up Down arrow control


'------------------------------------------------------------------------------
' Include files
'------------------------------------------------------------------------------
%USEMACROS = 1

#INCLUDE "Win32API.inc"
#INCLUDE "CommCtrl.inc"
#INCLUDE "InitCtrl.inc"


'------------------------------------------------------------------------------
' Equates
'------------------------------------------------------------------------------
%IDC_START = %WM_USER + 2048
%IDC_STOP  = %WM_USER + 2049
%IDC_ANIM  = %WM_USER + 2050


'------------------------------------------------------------------------------
' Main callback
'------------------------------------------------------------------------------
CALLBACK FUNCTION DlgProc () AS LONG

    STATIC hAnimate AS DWORD

    SELECT CASE CB.MSG

    CASE %WM_INITDIALOG
        CONTROL HANDLE CB.HNDL, %IDC_ANIM TO hAnimate
        Animate_Open hAnimate, "FILECOPY.AVI"

    CASE %WM_COMMAND
        ' Trap only click events
        IF CB.CTLMSG <> %BN_CLICKED THEN EXIT SELECT

        SELECT CASE CB.CTL
            CASE %IDC_START
                CONTROL DISABLE   CB.HNDL, %IDC_START
                CONTROL ENABLE    CB.HNDL, %IDC_STOP
                CONTROL SET FOCUS CB.HNDL, %IDC_STOP
                Animate_Play(hAnimate, 0, -1, -1)

            CASE %IDC_STOP
                CONTROL DISABLE   CB.HNDL, %IDC_STOP
                CONTROL ENABLE    CB.HNDL, %IDC_START
                CONTROL SET FOCUS CB.HNDL, %IDC_START
                Animate_Stop(hAnimate)

            CASE %IDCANCEL
                DIALOG END CB.HNDL, 0
        END SELECT

    CASE %WM_SYSCOLORCHANGE
        ' If user changes color scheme, forward the notification to the control
        CONTROL SEND CB.HNDL, %IDC_ANIM, CBMSG, CBWPARAM, CBLPARAM

    END SELECT

END FUNCTION


'------------------------------------------------------------------------------
' Main entry point for the application
'------------------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG

    LOCAL hDlg AS DWORD

    InitComCtl32(%ICC_ANIMATE_CLASS)

    DIALOG NEW 0, "Animation demo",,, 185, 60, %WS_CAPTION OR %WS_SYSMENU, _
        0 TO hDlg

    CONTROL ADD BUTTON, hDlg, %IDC_START, "&Start",  6, 40,  55,  14
    CONTROL ADD BUTTON, hDlg, %IDC_STOP,  "Sto&p",  65, 40,  55,  14, _
        %WS_DISABLED OR %WS_TABSTOP
    CONTROL ADD BUTTON, hDlg, %IDCANCEL,  "E&xit", 124, 40,  55,  14
    CONTROL ADD "SysAnimate32", hDlg, %IDC_ANIM, "", 6, 6, 172, 24, _
        %WS_CHILD OR %WS_VISIBLE OR %ACS_CENTER OR %ACS_TRANSPARENT

    DIALOG SHOW MODAL hDlg CALL DlgProc

END FUNCTION
